## 单链表基础知识

单链表是一种通过指针串联在一起的线性结构，每一个节点由两部分组成，一个是数据域一个是指针域（存放指向下一个节点的指针），最后一个节点的指针域指向 NULL（空指针的意思）。链接的入口节点称为链表的头结点也就是 head。

数组在内存中是连续分布的，但是链表在内存中可不是连续分布的。链表是通过指针域的指针链接在内存中各个节点。所以链表中的节点在内存中不是连续分布的 ，而是散乱分布在内存中的某地址上，分配机制取决于操作系统的内存管理。

定义链表节点的方式：

```c++
struct ListNode {
    int val; //节点上储存的元素
    ListNode* next; //指向下一个节点的指针
    ListNode(int x) : val(x), next(NULL) {} //节点的构造函数
};
```

不定义构造函数 C++ 会生成一个默认的构造函数。

两者的区别如下：

```c++
//通过自定义构造函数初始化节点
ListNode* head = new ListNode(2);
```

```c++
//使用默认构造函数初始化节点
ListNode* head = new ListNode();
head->val = 2;
```

使用默认构造函数，在初始化的时候不能直接给变量赋值。

## 单链表的操作

### 1.添加操作（`ListNode` 为定义的链表名）

![添加操作](./Images/单链表基础知识.1.jpg)

### 2.删除操作

![删除操作](./Images/单链表基础知识.2.jpg)

需要知道被删除节点的前一个结点

将 B 指向 C 的指针直接指向 D，然后手动 delete C 的内存。
