# LeetCode 2. 两数相加

## 题目：

给你两个 非空 的链表，表示两个非负的整数。它们每位数字都是按照 逆序 的方式存储的，并且每个节点只能存储 一位 数字。

请你将两个数相加，并以相同形式返回一个表示和的链表。

你可以假设除了数字 0 之外，这两个数都不会以 0 开头。

 ![示例1](./Images/02两数相加.jpg)

```c++
输入：l1 = [2,4,3], l2 = [5,6,4]
输出：[7,0,8]
解释：342 + 465 = 807.
```

### **提示：**

- 每个链表中的节点数在范围 `[1, 100]` 内
- `0 <= Node.val <= 9`
- 题目数据保证列表表示的数字不含前导零

## 思路：

考虑相加之外，还要考虑**进位**

### 代码部分：

```c++
class Solution {
public:
    ListNode* addTowNumbers(ListNode* l1, ListNode* l2) {
		ListNode* head = nullptr;
        ListNode* tial = nullptr;
        int carry = 0; //用来保存进位
        while(l1 || l2) {
            int n1 = l1 ? l1->val : 0;
            int n2 = l2 ? l2->val : 0;
            int sum = n1 + n2 + carry
            if (!head) {
                head = tial = new ListNode(sum % 10);
            }else {
                tial->next = new ListNode(sum % 10);
                tial = tial->next;
            }
			carry = (n1 + n2) / 10;
            if (l1) l1 = l1->next;
            if (l2) l2 = l2->next;
        }
        if (carry > 0) {
            tial->next = new ListNode(carry); //如果最后的进位不为 0 则需新建一个节点
        }
        return head;
    }
};
```

