# LeetCode 202. 快乐数

## 题目

编写一个算法来判断一个数 `n` 是不是快乐数。

「快乐数」 定义为：

对于一个正整数，每一次将该数替换为它每个位置上的数字的平方和。
然后重复这个过程直到这个数变为 `1`，也可能是 **无限循环** 但始终变不到 `1`。
如果这个过程 结果为 `1`，那么这个数就是快乐数。
如果 `n` 是 **快乐数** 就返回 `true` ；不是，则返回 `false` 。

### 示例 1：

输入：`n = 19`
输出：`true`
解释：
12 + 92 = 82
82 + 22 = 68
62 + 82 = 100
12 + 02 + 02 = 1

### 示例 2：

输入：`n = 2`
输出：`false`

### 提示：

`1 <= n <= 231 - 1`

## 思路：

如果循环不出 `1` 也就是进入了无限循环则 `sum` 会重复出现

判断是否 `sum` 重复出现，重复出现则不是快乐数

**当我们遇到了要快速判断一个元素是否出现集合里的时候，就要考虑哈希法了。**

## 代码部分：

```c++
class Solution {
public:
	int getSum(int n) { //创建函数循环计算每个位的平方相加之和
        int sum = 0;
        while(n) {
            sum += (n % 10) * (n % 10);
            n = n / 10;
        }
        return sum;
    }
    bool isHappy(int n) {
        underored_set<int> set; //创建一个哈希集合
        while (1) { 
			int sum = getSum(n); 
            if (sum == 1) { 
                return true;
            }
            if (set.find(sum) != set.end()) { //判断 sum 是否第二次出现在集合
                return false;
            }
            else {
                set.insert(sum);
            }
            n = sum; //更新循环
        }
    }
};
```
