# LeetCode 203. 移除链表元素

## 题目

给你一个链表的头节点 `head` 和一个整数 `val` ，请你删除链表中所有满足 `Node.val == val` 的节点，并返回 **新的头节点** 。

## 思路 & 代码

虚拟头节点，从前往后寻找

```c++
class Solution {
public:
    ListNode* removeElements(ListNode* head, int val) { 
        //删除头节点
        //判断头节点是否为空
        while (head != NULL && head->val == val) { 
            ListNode* tmp = head;
            head = head->next;
            delete tmp;
        }
        //删除非头节点
        ListNode* cur = head;
        while (cur != NULL && cur->next != NULL) { //遇到结尾的空指针则结束循环
            if (cur->next->val == val) { //判断这个值是否要删除
                ListNode* tmp = cur->next; //创建一个临时值
                cur->next = cur->next->next; //意思就是 cur 的指向的下一个值
                //变成 cur 指向的下一个值的下一个值，就是跳过目标
                delete tmp; //释放掉 tmp 的内存
            }
            else {
                cur = cur->next;
            }
        }
        return head;
    }
```

不设置虚拟头节点，需要单独处理头节点

```c++
class Solution {
public:
    ListNode* removeElements(ListNode* head, int val) { 
        ListNode* dummyHead = new ListNode(0);  //设置一个虚拟节点头
        dummyHead->next = head; //将虚拟节点指向 head，方便以后执行删除操作
        ListNode* cur = dummyHead; //节点头为 dummyHead
        while (cur->next != NULL) {
            if (cur->next->val == val) {
                ListNode* tmp = cur->next;
                cur->next = cur->next->next;
                delete tmp;
            }
            else { //不要忘记加跳出循环条件
                cur = cur->next;
            }
        }
        head = dummyHead->next;
        delete dummyHead;
        return head;
    }
};
```
