# LeetCode 21. 合并两个有序链表

## 题目：

将两个升序链表合并为一个新的 **升序** 链表并返回。新链表是通过拼接给定的两个链表的所有节点组成的。 

 ![示例1](./Images/lc.21.jpg)

### **提示：**

- 两个链表的节点数目范围是 `[0, 50]`
- `-100 <= Node.val <= 100`
- `l1` 和 `l2` 均按 **非递减顺序** 排列

## 思路：

链表题一定要多画图解，有时候画出图就有了思路

因为是有序链表，创建一个哨兵节点作为虚拟头节点，如果节点值相等随便默认先连接某一个链表的节点就行。

## 代码部分：

```cpp
class Solution {
public:
    ListNode* mergeTwoLists(ListNode* list1, ListNode* list2) {
        ListNode* preHead = new ListNode(-1); //虚拟节点头
        ListNode* pre = preHead; //用来保存某个节点
        while(list1 != NULL && list2 != NULL) {
            if(list1->val > list2->val) { //比较值的大小，判断下一个连接的节点
                pre->next = list2;
                list2 = list2->next;
            }
            else {
                pre->next = list1;
                list1 = list1->next;
            }
            pre = pre->next;
        }
        pre->next = list1 == nullptr ? list2 : list1; //如果有一个链表结束了，则直接连接非空的链表
        return preHead->next;
    }
};
```

