# `LeetCode` 328. 奇偶链表

## 题目描述：

给定单链表的头节点 `head` ，将所有索引为奇数的节点和索引为偶数的节点分别组合在一起，然后返回重新排序的列表。

第一个节点的索引被认为是 **奇数** ，第二个节点的索引为 **偶数** ，以此类推。

请注意，偶数组和奇数组内部的相对顺序应该与输入时保持一致。

你必须在 **O(1)** 的额外空间复杂度和 **O(n)** 的时间复杂度下解决这个问题。

![示例1](./Images/328. 示例.jpg)

```
输入: head = [1,2,3,4,5]
输出: [1,3,5,2,4]
```

## 解题思路：

分为两部分，奇数下标链表和偶数下标链表

创建四个指针，一个指向奇下标链表的头节点，一个指向偶数下标的头节点。一个用来更新奇数下标链表的指针，一个用来更新偶数下标链表的指针。其中指向奇下标链表的头节点就是整个链表的头节点，可以不用新建，就用 head 就可以。

从第 3 个点开始遍历，依次更新奇数下标链表和偶数下标链表

遍历完后，奇数链的尾连向偶链的头，偶链的尾为空，返回奇数链的头

## 代码部分：

解法1：

```c++
class Solution {
public:
    ListNode* oddEvenList(ListNode* head) {
        if (head == NULL || head->next == NULL) return head;
        ListNode* cur = head; //奇链表指针
        ListNode* preHead = head->next; //偶链表头
        ListNode* pre = preHead; //偶链表指针
        for (ListNode* p = cur->next->next; p;) { //从第二个奇数下标开始，并判断是否为空
            cur = cur->next = p; //指向下一个奇数下标
            p = p->next; //更新p到偶数下标
            if (p) { //判断是否为空
                pre = pre->next = p; //更新偶数下标链表
                p = p->next; //更新 p 到下一个奇数下标
            }
        }
        cur->next = preHead; //奇数链表下标与偶数下标链表结合
        pre->next = nullptr; //链表最后的元素指向空指针
        return head;
    }
};
```

![解法1](./Images/score1.png)

解法2：

```c++
class Solution {
public:
    ListNode* oddEvenList(ListNode* head) {
        if (head == NULL || head->next == NULL) return head;
        ListNode* cur = head; //奇链表指针
        ListNode* preHead = head->next; //偶链表头
        ListNode* pre = preHead; //偶链表指针
        while (pre != NULL && pre->next != NULL) {
            cur->next = pre->next; //指向下一个奇数下标的点，也就是偶数下标的下一个
            cur = cur->next;
            pre->next = cur->next; //同理
            pre = pre->next;
        }
        cur->next = preHead; //奇数链表下标与偶数下标链表结合
        return head;
    }
};
```

![解法2](./Images/score.png)
